;-----------------------------------------------------
;-----------------------------------------------------
;-----------------------------------------------------
;
; Routine de nuances de gris
; Par Flavien Racine
; Base programmee par David Elsworth et Xavier Vassor
; Base HW2 tiree d'UniversalOS de JM
; Version _nostub
; Systemes supportes : TI-89/TI-92+/V200/HW1/HW2 et 
; VirtualTI sauf en emulation V200, detecte comme HW2
;
;-----------------------------------------------------
;-----------------------------------------------------
;-----------------------------------------------------

GrayScalesOn:
	movem.l		d0-d7/a0-a6,-(a7)

	move.l		#3840*2+8,-(a7)
	CALL		HeapAlloc
	addq.l		#4,a7
	move.w		d0,Planes_Handle
	beq		ErreurAllocation
	move.w		d0,-(a7)
	CALL		HeapDeref
	lea		2(a7),a7


	move.l		#gray4man,d1
	cmp.w		#HARDWARE1,HARDWARE
	beq		continue_activation
	move.l		a0,Plane0
	lea		3840(a0),a0
	move.l		a0,Plane1
	move.w		#1,flag
	clr.l		something
	move.w		#1,flag
	move.l		#gray4man_hw2,d1
	bsr		installgray
	bsr		PortSetPlane0
	or.w		#$FFFF,d0
	bra		ErreurAllocation

continue_activation:
	move.l		a0,d0
	addq.l		#7,d0
	lsr.l		#3,d0
	move.w		d0,table+2*0
	lsl.l		#3,d0
	move.l		d0,Plane1
	move.l		d0,a0
	lea		3840(a0),a0
	move.l		a0,d0
	move.l		d0,Plane0
	lsr.l		#3,d0
	move.w		d0,table+2*1 
	move.w		d0,table+2*2

	bsr		installgray
	bsr		PortSetPlane0
	or.w		#$FFFF,d0
ErreurAllocation:
	movem.l		(a7)+,d0-d7/a0-a6
	rts


installgray:
	bsr		NettoyeEcranGray
	move.w		#$0700,d0
	trap		#1
	move.l		$64,old_int_1
	bclr.b		#2,$600001
	move.l		d1,$64
	bset.b		#2,$600001
	trap		#1
	rts



gray4man:
	move.w		#$2700,sr

	add.w		#1,vbl_phase
	and.w		#3,vbl_phase 
	bne		int_1_skip

	movem.l		d0/a0,-(a7)
	move.w		phase(pc),d0
	lea		table(pc),a0
	move.w		0(a0,d0.w),($600010)
	add.w		#2,d0
	cmp.w		#2*3,d0
	bne		no_wrap
	clr.w		d0
	clr.w		GrayFlag
no_wrap:
	move.w		d0,phase
	movem.l		(a7)+,d0/a0
int_1_skip:

	move.l		old_int_1,-(a7)
	rts




gray4man_hw2:
	move		#$2700,sr
	movem.l		d0-d7/a0-a6,-(a7)
startagain:
	moveq		#0,d1
	lea		something(pc),a0
	move.w		(a0),d0
	bne.s		after_check
	move.l		(a0),d0
	move.b		$70001D,d1
	eor.b		d0,d1
	bpl		to_oldint
	eor.l		d1,(a0)
	move.w		#$A00,d0
back:
	addq.w		#1,(a0)+
	bra.s		forward
after_check:
	subq.w		#1,d0
	beq.s		back
	clr.w		(a0)+
	move.w		#$500,d0
forward:
	tst.b		(a0)
	beq		skip
	tst.w		d0
	bne		skip_flag
	not.w		flag
skip_flag:
	cmp.w		#1,flag
	beq		dark_plane_hw2
	move.l		Plane1,a0
	bra		copy_hw2
dark_plane_hw2:
	move.l		Plane0,a0
	cmp.w		#$A00,d0
	bne		copy_hw2
	clr.w		GrayFlag

copy_hw2:
	lea		$4C00,a1
	adda.w		d0,a0
	adda.w		d0,a1

	move.w		#319,d0
	BoucleCopieGrays:
		move.l		(a0)+,(a1)+
		dbra		d0,BoucleCopieGrays

skip:
	lea		something(pc),a0
	move.w		(a0)+,d0
	beq		startagain
	subq.w		#1,d0
	bne.s		to_oldint
	subq.b		#4,(a0)
	bcc.s		to_oldint
	move.b		#8,(a0)
to_oldint:
	movem.l		(a7)+,d0-d7/a0-a6
	move		#$2100,sr
	
	move.l		old_int_1,-(a7)
	rts


GrayScalesOff:
	movem.l		d0-d7/a0-a6,-(a7)
	CALL		PortRestore
	move.w		#$700,d0
	trap		#1
	bclr.b		#2,$600001
	move.l		old_int_1,$64
	bset.b		#2,$600001
	clr.l		old_int_1
	clr.w		d0
	trap		#1
	clr.w		phase
	clr.w		vbl_phase

	move.l		#$4C00,d0
	lsr.l		#3,d0
	move.w		d0,table+2*1

	move.w		table+2(pc),($600010)
fin_desactivation:
	move.w		Planes_Handle(pc),-(a7)
	CALL		HeapFree
	addq.l		#2,a7
graylib_fail:
	movem.l		(a7)+,d0-d7/a0-a6
	clr.l		d0
	rts


PortSetPlane0:
	move.l		#239*65536+127,-(a7)
	move.l		Plane0,-(a7)
	CALL		PortSet
	lea		8(a7),a7
	rts

PortSetPlane1:
	move.l		#239*65536+127,-(a7)
	move.l		Plane1,-(a7)
	CALL		PortSet
	lea		8(a7),a7
	rts

something		dc.l	0
flag			dc.w	0
saved_ssp		dc.l	0
Planes_Handle		dc.w	0
Plane0			dc.l	0
Plane1			dc.l	0
old_int_1		dc.l	0
phase			dc.w	0
vbl_phase		dc.w	3
table			ds.w	6
GrayFlag		dc.w	0
